<?php
class KassaVOnlineApi {

    private static $user = ''; //Логин пользователя
    private static $key = ''; //Секрет пользователя
    private static $kkm_serial_number = ''; //Серийный номер кассы
    private static $kkm_connection_key = ''; //Секрет кассы

    public function print() { //Печать чека
        $url = 'https://kassa-v-online.ru/api/print';

        $params = array(
            'kkm_serial_number' => self::$kkm_serial_number,
            'kkm_connection_key' => self::$kkm_connection_key,
            'receipt' => array(
                'ffd' => '1.05', //Версия ФФД. Текущая 1.05
                'type' => 'cash_in', //cash_in - ПРИХОД, return_cash_in - ВОЗВРАТ ПРИХОДА
                'is_electronic' => 0, //1 - не печатать бумажный чек (отправка на email), 0 - печатать бумажный чек
                'cashier' => 'Иванов И.И.', //ФИО кассира
                'cashier_inn' => '', //ИНН кассира
                'client_tel' => '', //телефон покупателя
                'client_email' => '', //email покупателя
                'items' => array( //позиции чека
                    array(
                        'title' => 'Туристический продукт. Турция, Белек',
                        'price' => 105200,
                        'quantity' => 1,
                        'tax_type_name' => 'NO', //НДС: 'NO','VAT18','VAT10','VAT118','VAT110','VAT0','VAT20','VAT120'
                        'payment_type' => 4, //Признак способа расчета: 1 - Предоплата 100%, 2 - Предоплата, 3 - Аванс, 4 - Полный расчет, 5 - Частичный расчет и кредит, 6 - Передача в кредит, 7 - Оплата кредита
                        'payment_subject' => 12, //Признак предмета расчета: 1 - Товар, 2 - Подакцизный товар, 3 - Работа, 4 - Услуга, 5 - Ставка игры, 6 - Выигрыш игры, 7 - Ставка лотереи, 8 - Выигрыш лотереи, 9 - Предоставление РИД, 10 - Платеж, 11 - Агентское вознаграждение, 12 - Составной предмет расчета, 13 - Иной предмет расчета, 14 - Имущественное право, 17 - Торговый сбор, 18 - Курортный сбор, 19 - Залог
                        'agent_type' => 'NONE', //Признак агента: 'NONE' - Нет, 'COMMISSION_AGENT' - Комиссионер, 'ANOTHER' - Агент
                        'suplier_name' => '', //Наименование поставщика (обязательно, если задан Признак агента)
                        'suplier_inn' => '', //ИНН поставщика (обязательно, если задан Признак агента)
                        'suplier_phone' => '' //Телефон поставщика (обязательно, если задан Признак агента)
                    )
                ),
                'payments' => array( //оплаты
                    array(
                        'type' => 'cash', //Способ оплаты: 'cash' - наличными, 'electronically' - безналичными, 'prepaid' - предоплатой, 'credit' - постоплатой, 'other' - встречным предоставлением
                        'amount' => 105200
                    )
                )
            )
        );

        $request = array('params' => json_encode($params));
        $result = self::posttoserver($url, $request);

        var_dump(json_decode($result, true));
    }

    public function printX() { //Печать X отчета
        $url = 'https://kassa-v-online.ru/api/print';

        $params = array(
            'kkm_serial_number' => self::$kkm_serial_number,
            'kkm_connection_key' => self::$kkm_connection_key,
            'receipt' => array(
                'type' => 'x-report'
            )
        );

        $request = array('params' => json_encode($params));
        $result = self::posttoserver($url, $request);

        var_dump(json_decode($result, true));
    }

    public function printZ() { //Печать Z отчета
        $url = 'https://kassa-v-online.ru/api/print';

        $params = array(
            'kkm_serial_number' => self::$kkm_serial_number,
            'kkm_connection_key' => self::$kkm_connection_key,
            'receipt' => array(
                'type' => 'z-report'
            )
        );

        $request = array('params' => json_encode($params));
        $result = self::posttoserver($url, $request);

        var_dump(json_decode($result, true));
    }

    public function status() { //Статус печати чека
        $url = 'https://kassa-v-online.ru/api/status';

        $params = array(
            'receipt_id' => 157989, //id чека
            'session_info' => 0 //возвращать информацию об открытии/закрытии смены
        );

        $request = array('params' => json_encode($params));
        $result = self::posttoserver($url, $request);

        var_dump(json_decode($result, true));
    }

    public function info() { //Информация по чеку
        $url = 'https://kassa-v-online.ru/api/info';

        $params = array(
            'receipt_id' => 157989
        );

        $request = array('params' => json_encode($params));
        $result = self::posttoserver($url, $request);

        var_dump(json_decode($result, true));
    }

    public static function posttoserver($url, $request) {
        $request['user'] = self::$user;
        $request['key'] = self::$key;

        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $request);

        $return = curl_exec($ch);
        curl_close($ch);

        if ($return === false) {
            $return = 'error';
        }

        return $return;
    }
}